#!/bin/sh

binDir=`dirname "$0"`
. "$binDir"/setupCmdLine.sh

isJavaOption=false
nonJavaOptionCount=1
for option in "$@" ; do
  if [ "$option" = "-javaoption" ] ; then
     isJavaOption=true
  else
     if [ "$isJavaOption" = "true" ] ; then
        javaOption="$javaOption $option"
        isJavaOption=false
     else
        # if not a javaoption always add the command line option
        nonJavaOption[$nonJavaOptionCount]="$option"
        nonJavaOptionCount=$((nonJavaOptionCount+1))
     fi
  fi
done

#Define the default JVM path.
JAVA_PATH="$JAVA_HOME/bin/java"

#Platform specific args...
# Set java options for performance
PLATFORM=`/bin/uname`
case $PLATFORM in
  AIX)
    PERF_JVM_OPTIONS="-Xms256m -Xmx512m -Xquickstart"
    CONSOLE_ENCODING=-Dws.output.encoding=console
    LIBPATH="$WAS_LIBPATH":$LIBPATH
    export LIBPATH ;;
  Linux)
    PERF_JVM_OPTIONS="-Xms256m -Xmx512m -Xj9 -Xquickstart"
    CONSOLE_ENCODING=-Dws.output.encoding=console
    LD_LIBRARY_PATH="$WAS_LIBPATH":$LD_LIBRARY_PATH
    export LD_LIBRARY_PATH ;;
  HP-UX)
    PERF_JVM_OPTIONS="-Xms256m -Xmx512m -XX:PermSize=40m -XX:+UnlockDiagnosticVMOptions -XX:+UnsyncloadClass"
    CONSOLE_ENCODING=-Dws.output.encoding=console
    SHLIB_PATH="$WAS_LIBPATH":$SHLIB_PATH
    export SHLIB_PATH ;;	
  OS/390)
    PERF_JVM_OPTIONS="-Xquickstart"
    EXTRA_D_ARG=-Dfile.encoding=ISO8859-1
    EXTRA_X_ARG=-Xnoargsconversion ;;
esac

#WAS_MIGR_DEBUG_PRE="-Djava.compiler=NONE -Xdebug -Xnoagent -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8888"

$JAVA_PATH \
  $WAS_MIGR_DEBUG_PRE \
  "$OSGI_INSTALL" "$OSGI_CFG" \
  $EXTRA_X_ARG \
  $CONSOLE_ENCODING \
  -Dws.ext.dirs="$WAS_EXT_DIRS" \
  -Djava.endorsed.dirs="$WAS_ENDORSED_DIRS" \
  -Djava.ext.dirs="$WAS_JAVA_EXT_DIRS" \
  -Dwas.install.root="$WAS_HOME" \
  -Dcom.ibm.ws.migration.ulimit=`ulimit -n` \
  -Dcom.ibm.ws.migration.javaoptions="$javaOption" \
  $PERF_JVM_OPTIONS \
  $WAS_LOGGING \
  $EXTRA_D_ARG \
  $javaOption \
  -classpath "$WAS_CLASSPATH" com.ibm.wsspi.bootstrap.WSPreLauncher \
  -nosplash -clean -application com.ibm.ws.bootstrap.WSLauncher com.ibm.ws.migration.WASPreUpgrade "${nonJavaOption[@]}"
  rc=$?
  exit $rc